//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
    ServerSocket1->Port = 7778;
    ServerSocket1->Active = true;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ServerSocket1ClientRead(TObject *Sender,
      TCustomWinSocket *Socket)
{
    //WARN: pod 98 wymagana kontrola dlugosci danych wprowadzanych do memo
    AnsiString tmp;
    tmp = Memo1->Text;
    tmp = tmp + Socket->ReceiveText();
    Memo1->Text = tmp;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ServerSocket1ClientConnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
    if( ServerSocket1->Socket->ActiveConnections > 1)
    {
        ServerSocket1->Socket->Connections[1]->SendText("Sorry, only one client allowed.");
        Socket->Close();    //odmow dostepu
        Memo1->Lines->Add("New connection not accepted");
    }
    else
    {
        btnSend->Enabled = true;
        Socket->SendText("Connection established\r\n");
        Memo1->Lines->Add("Client connected");
    }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnSendClick(TObject *Sender)
{
    if(ServerSocket1->Socket->ActiveConnections > 0)
    {
         ServerSocket1->Socket->Connections[0]->SendText(Edit1->Text);
        //ServerSocket1->Socket->SendText(Edit1->Text);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ServerSocket1ClientDisconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
    //gdy rozlacza sie ostatni klient
    if(ServerSocket1->Socket->ActiveConnections < 2)
    {
        btnSend->Enabled = false;
        Memo1->Lines->Add("Client disconnected");
    }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCreate(TObject *Sender)
{
Application->OnMinimize = AppMinimize;

}
//---------------------------------------------------------------------------



//f. zwiazane z ikona traya
void __fastcall TForm1::DrawItem(TMessage& Msg)
{
     IconDrawItem((LPDRAWITEMSTRUCT)Msg.LParam);
     TForm::Dispatch(&Msg);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MyNotify(TMessage& Msg)
{
    POINT MousePos;
    switch(Msg.LParam)
    {
        case WM_RBUTTONUP:
            if (GetCursorPos(&MousePos))
            {
                PopupMenu1->PopupComponent = Form1;
                SetForegroundWindow(Handle);
                PopupMenu1->Popup(MousePos.x, MousePos.y);
            }
            else
                AppRestore(NULL);
            break;
        case WM_LBUTTONUP:  //dummy
            //ToggleState();
            break;
        case WM_LBUTTONDBLCLK:  //lewy dwumlask
            AppRestore(NULL);
            break;
        default:
            break;
    }
    TForm::Dispatch(&Msg);
}


void __fastcall TForm1::FormDestroy(TObject *Sender)
{
TrayMessage(NIM_DELETE);

}
//---------------------------------------------------------------------------


bool __fastcall TForm1::TrayMessage(DWORD dwMessage)
{
   NOTIFYICONDATA tnd;
   PSTR pszTip;
   pszTip="costam";
   //pszTip = TipText();

   tnd.cbSize          = sizeof(NOTIFYICONDATA);
   tnd.hWnd            = Handle;
   tnd.uID             = IDC_MYICON;
   tnd.uFlags          = NIF_MESSAGE | NIF_ICON | NIF_TIP;
   tnd.uCallbackMessage	= MYWM_NOTIFY;

   if (dwMessage == NIM_MODIFY)
    {
        tnd.hIcon		= (HICON)IconHandle();
        if (pszTip)
           lstrcpyn(tnd.szTip, pszTip, sizeof(tnd.szTip));
	    else
        tnd.szTip[0] = '\0';
    }
   else
    {
        tnd.hIcon = NULL;
        tnd.szTip[0] = '\0';
    }

   return (Shell_NotifyIcon(dwMessage, &tnd));
}

PSTR __fastcall TForm1::TipText(void)
{
    char textbuf[50];
    strcpy(textbuf, "tooltip...uzupelnic" );
    return textbuf;
}


//---------------------------------------------------------------------------
HICON __fastcall TForm1::IconHandle(void)
{
    return Image1->Picture->Icon->Handle;
}

//---------------------------------------------------------------------------
LRESULT IconDrawItem(LPDRAWITEMSTRUCT lpdi)
{
	HICON hIcon;
	hIcon = (HICON)LoadImage(g_hinst, MAKEINTRESOURCE(lpdi->CtlID), IMAGE_ICON,
		16, 16, 0);
	if (!hIcon)
		return(FALSE);
	DrawIconEx(lpdi->hDC, lpdi->rcItem.left, lpdi->rcItem.top, hIcon,
		16, 16, 0, NULL, DI_NORMAL);
	return(TRUE);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AppMinimize(TObject *Sender)
{
//if(enableTray==true)    //minimalizacja do traya
//    {
    TrayMessage(NIM_ADD);
    TrayMessage(NIM_MODIFY);
    Form1->Hide();      //kolejnosc jest chyba wazna
//    }
}

void __fastcall TForm1::AppRestore(TObject *Sender)
{
//if(enableTray==true)    //przywrcenie
//    {
    Form1->Show();
    TrayMessage(NIM_DELETE);
    Form1->WindowState=wsNormal;
    Application->Restore();
    Application->BringToFront();
//    }
}

void __fastcall TForm1::RestoreClick(TObject *Sender)
{
AppRestore(NULL);    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
this->Close();
}
//---------------------------------------------------------------------------

